#!/bin/gawk -f

# Read line from "process".
# Return whether a line was available.
#
function next_line(process) {
  s = (process |& getline line)
  if (s < 0) {
    printf("Error reading from %s.", process) >"/dev/stderr"
    exit(1)
  }
  return (s > 0)
}

BEGIN {
  find_provides = "/usr/lib/rpm/find-provides"
  find_requires = "/usr/lib/rpm/find-requires"
}

{
  print |& find_provides
  print |& find_requires
}

END {
  close(find_provides, "to")
  close(find_requires, "to")
  while (next_line(find_provides))
	known[line]
  while (next_line(find_requires))
	if (!(line in known))
		print line
  close(find_provides)
  close(find_requires)
}
